using dodohold.core;
using CSRedis;
using System.Data;

namespace molilian.core
{
    public partial class TkLogCore
    {
        static string queue_parse_dy_key = "queue:parse_logs:dy";

        public static int task_insert_parse_dy_logs(IDbConnection connection, IDbTransaction transaction, int limit, CSRedisClient redis)
        {
            int total = 0;


            for (int i = 0; i < limit; i++)
            {
                var data = redis.LPop<DyDataDTO>(queue_parse_dy_key);
                if (data == null) break;
                new DBContext.Table(connection, "tk_parse_logs")
                    .Add("end_point", data.end_point)
                    .Add("channel", (int)data.channel)
                    .Add("accountId", data.accountId)
                    .Add("accountName", data.accountName)
                    .Add("rawContent", data.rawContent)
                    .Add("success", data.success)
                    .Add("message", data.message)
                    .Add("reason", data.reason)
                    .Add("content", data.content)
                    .Add("itemId", data.itemId)
                    .Add("itemName", data.itemName)
                    .Add("pic", data.pic)
                    .Add("couponAmount", data.couponAmount)
                    .Add("promotionPrice", data.promotionPrice)
                    .Add("taoToken", data.taoToken)
                    .Add("shortLinkurl", data.shortLinkurl)
                    .Add("deeplink_url", data.deeplink_url)
                    .Add("elapsedTime", data.elapsedTime)
                    .Add("subCode", data.subCode)
                    .Add("ip", data.ip)
                    .Add("oaid", data.oaid)
                    .Add("create_time", data.create_time)
                    .Create(DBContext.InsertType.NORMAL, transaction);
                total++;
            }
            return total;
        }

        public static async Task ParseLogAsync(DyDataDTO response)
        {
            try
            {
                var ts = DateTime.Now - response.create_time;
                response.elapsedTime = (int)ts.TotalMilliseconds;
                _ = RedisHelper.RPushAsync(queue_parse_dy_key, response);

                if (!response.ip.Contains("127.0.0"))
                {
                    saveParseCache(response.channel.ToString(), response.accountId,
                        response.accountName, response.success, response.message, response.reason,
                        response.deeplink_url);
                }

            }
            catch (Exception ex) { }
        }
    }

}
